Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/grid.f90	(revision 5600)
@@ -1535,7 +3127,457 @@
 
    END FUNCTION grid_distance
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function get fine grid offset.
+   !-------------------------------------------------------------------
+   !> @brief This function get offset between fine grid and coarse grid.
+   !
+   !> @details
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !> offset value could be 0,1,..,rho-1
+   !
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] td_coord0 coarse grid coordinate 
+   !> @param[in] id_imin0  coarse grid lower left corner i-indice of fine grid domain
+   !> @param[in] id_jmin0  coarse grid lower left corner j-indice of fine grid domain
+   !> @param[in] id_imax0  coarse grid upper right corner i-indice of fine grid domain
+   !> @param[in] id_jmax0  coarse grid upper right corner j-indice of fine grid domain
+   !> @param[in] td_coord1 fine   grid coordinate 
+   !> @param[in] id_rho    array of refinement factor
+   !> @param[in] cd_point  Arakawa grid point
+   !> @return offset array (/ (/i_offset_left,i_offset_right/),(/j_offset_lower,j_offset_upper/) /)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_fine_offset_ff( td_coord0, &
+   &                                  id_imin0, id_jmin0, id_imax0, id_jmax0, &
+   &                                  td_coord1, id_rho, cd_point )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP)                    , INTENT(IN) :: td_coord0
+      TYPE(TMPP)                    , INTENT(IN) :: td_coord1
+
+      INTEGER(i4)                   , INTENT(IN) :: id_imin0
+      INTEGER(i4)                   , INTENT(IN) :: id_jmin0
+      INTEGER(i4)                   , INTENT(IN) :: id_imax0
+      INTEGER(i4)                   , INTENT(IN) :: id_jmax0
+
+      INTEGER(i4)     , DIMENSION(:), INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)              , INTENT(IN), OPTIONAL :: cd_point
+
+      ! function
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_fine_offset_ff
+
+      ! local variable
+      INTEGER(i4) :: il_imin0
+      INTEGER(i4) :: il_jmin0
+      INTEGER(i4) :: il_imax0
+      INTEGER(i4) :: il_jmax0
+      
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+      
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost0
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost1
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
+
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon0
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lat0
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon1
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lat1
+
+      TYPE(TVAR) :: tl_lon0
+      TYPE(TVAR) :: tl_lat0
+      TYPE(TVAR) :: tl_lon1
+      TYPE(TVAR) :: tl_lat1
+
+      TYPE(TMPP) :: tl_coord0
+      TYPE(TMPP) :: tl_coord1
+      
+      ! loop indices
+      !----------------------------------------------------------------
+      ! init
+      grid__get_fine_offset_ff(:,:)=-1
+
+      ALLOCATE(il_rho(ip_maxdim))
+      il_rho(:)=1
+      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      ! copy structure
+      tl_coord0=mpp_copy(td_coord0)
+      tl_coord1=mpp_copy(td_coord1)
+
+      IF( .NOT. ASSOCIATED(tl_coord0%t_proc) .OR. &
+      &   .NOT. ASSOCIATED(tl_coord1%t_proc) )THEN
+         CALL logger_error("GRID GET FINE OFFSET: can not get coarse "//&
+         &  "grid indices. decompsition of mpp file "//TRIM(tl_coord0%c_name)//&
+         &  " and/or "//TRIM(tl_coord1%c_name)//" not defined." )
+      ELSE      
+         !1- Coarse grid
+         ! get ghost cell factor on coarse grid
+         il_xghost0(:,:)=grid_get_ghost( tl_coord0 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord0)
+
+         ! read coarse longitue and latitude
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord0)
+
+         CALL grid_del_ghost(tl_lon0, il_xghost0(:,:))
+         CALL grid_del_ghost(tl_lat0, il_xghost0(:,:))
+
+         ALLOCATE(dl_lon0(tl_lon0%t_dim(jp_I)%i_len, &
+         &                tl_lon0%t_dim(jp_J)%i_len ))
+
+         dl_lon0(:,:)=tl_lon0%d_value(:,:,1,1)
+
+         ALLOCATE(dl_lat0(tl_lat0%t_dim(jp_I)%i_len, &
+         &                tl_lat0%t_dim(jp_J)%i_len ))
+
+         dl_lat0(:,:)=tl_lat0%d_value(:,:,1,1)
+
+         ! clean
+         CALL var_clean(tl_lon0)
+         CALL var_clean(tl_lat0)
+
+         ! adjust coarse grid indices
+         il_imin0=id_imin0-il_xghost0(jp_I,1)
+         il_imax0=id_imax0-il_xghost0(jp_I,1)
+
+         il_jmin0=id_jmin0-il_xghost0(jp_J,1)
+         il_jmax0=id_jmax0-il_xghost0(jp_J,1)
+
+         !2- Fine grid
+         ! get ghost cell factor on fine grid
+         il_xghost1(:,:)=grid_get_ghost( tl_coord1 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord1)
+
+         ! read fine longitue and latitude
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
+ 
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord1)
+
+         CALL grid_del_ghost(tl_lon1, il_xghost1(:,:))
+         CALL grid_del_ghost(tl_lat1, il_xghost1(:,:))
+
+         ALLOCATE(dl_lon1(tl_lon1%t_dim(jp_I)%i_len, &
+         &                tl_lon1%t_dim(jp_J)%i_len ))
+
+         dl_lon1(:,:)=tl_lon1%d_value(:,:,1,1)
+
+         ALLOCATE(dl_lat1(tl_lat1%t_dim(jp_I)%i_len, &
+         &                tl_lat1%t_dim(jp_J)%i_len ))
+
+         dl_lat1(:,:)=tl_lat1%d_value(:,:,1,1)
+
+         ! clean
+         CALL var_clean(tl_lon1)
+         CALL var_clean(tl_lat1)
+ 
+         !3- compute
+         grid__get_fine_offset_ff(:,:)=grid_get_fine_offset( &
+         &                                         dl_lon0(:,:), dl_lat0(:,:),&
+         &                                         il_imin0, il_jmin0, &
+         &                                         il_imax0, il_jmax0, &
+         &                                         dl_lon1(:,:), dl_lat1(:,:),&
+         &                                         id_rho(:) )
+ 
+         DEALLOCATE(dl_lon0, dl_lat0)
+         DEALLOCATE(dl_lon1, dl_lat1)
+      ENDIF
+
+      ! clean 
+      CALL mpp_clean(tl_coord0)
+      CALL mpp_clean(tl_coord1)
+      DEALLOCATE(il_rho)
+
+   END FUNCTION grid__get_fine_offset_ff
+   !-------------------------------------------------------------------
+   !> @brief This function get offset between fine grid and coarse grid.
+   !
+   !> @details
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !> offset value could be 0,1,..,rho-1
+   !
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] dd_lon0   coarse grid longitude array 
+   !> @param[in] dd_lat0   coarse grid latitude  array
+   !> @param[in] id_imin0  coarse grid lower left corner i-indice of fine grid domain
+   !> @param[in] id_jmin0  coarse grid lower left corner j-indice of fine grid domain
+   !> @param[in] id_imax0  coarse grid upper right corner i-indice of fine grid domain
+   !> @param[in] id_jmax0  coarse grid upper right corner j-indice of fine grid domain
+   !> @param[in] td_coord1 fine   grid coordinate 
+   !> @param[in] id_rho    array of refinement factor
+   !> @param[in] cd_point  Arakawa grid point
+   !> @return offset array (/ (/i_offset_left,i_offset_right/),(/j_offset_lower,j_offset_upper/) /)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_fine_offset_cf( dd_lon0, dd_lat0, &
+   &                                  id_imin0, id_jmin0, id_imax0, id_jmax0, &
+   &                                  td_coord1, id_rho, cd_point )
+      IMPLICIT NONE
+      ! Argument
+      REAL(dp)       , DIMENSION(:,:), INTENT(IN) :: dd_lon0
+      REAL(dp)       , DIMENSION(:,:), INTENT(IN) :: dd_lat0
+      TYPE(TMPP)                     , INTENT(IN) :: td_coord1
+
+      INTEGER(i4)                    , INTENT(IN) :: id_imin0
+      INTEGER(i4)                    , INTENT(IN) :: id_jmin0
+      INTEGER(i4)                    , INTENT(IN) :: id_imax0
+      INTEGER(i4)                    , INTENT(IN) :: id_jmax0
+
+      INTEGER(i4)     , DIMENSION(:) , INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)               , INTENT(IN), OPTIONAL :: cd_point
+
+      ! function
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_fine_offset_cf
+
+      ! local variable
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+      
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost1
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
+
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon1
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lat1
+
+      TYPE(TVAR) :: tl_lon1
+      TYPE(TVAR) :: tl_lat1
+
+      TYPE(TMPP) :: tl_coord1
+      ! loop indices
+      !----------------------------------------------------------------
+      ! init
+      grid__get_fine_offset_cf(:,:)=-1
+
+      ALLOCATE(il_rho(ip_maxdim))
+      il_rho(:)=1
+      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      ! copy structure
+      tl_coord1=mpp_copy(td_coord1)
+
+      IF( .NOT. ASSOCIATED(tl_coord1%t_proc) )THEN
+         CALL logger_error("GRID GET FINE OFFSET: decompsition of mpp "//&
+         &  "file "//TRIM(tl_coord1%c_name)//" not defined." )
+      ELSE      
+
+         ! Fine grid
+         ! get ghost cell factor on fine grid
+         il_xghost1(:,:)=grid_get_ghost( tl_coord1 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord1)
+
+         ! read fine longitue and latitude
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat1=iom_mpp_read_var(tl_coord1, TRIM(cl_name))
+ 
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord1)
+
+         CALL grid_del_ghost(tl_lon1, il_xghost1(:,:))
+         CALL grid_del_ghost(tl_lat1, il_xghost1(:,:))
+
+         ALLOCATE(dl_lon1(tl_lon1%t_dim(jp_I)%i_len, &
+         &                tl_lon1%t_dim(jp_J)%i_len ))
+
+         dl_lon1(:,:)=tl_lon1%d_value(:,:,1,1)
+
+         ALLOCATE(dl_lat1(tl_lat1%t_dim(jp_I)%i_len, &
+         &                tl_lat1%t_dim(jp_J)%i_len ))
+
+         dl_lat1(:,:)=tl_lat1%d_value(:,:,1,1)
+
+         ! clean
+         CALL var_clean(tl_lon1)
+         CALL var_clean(tl_lat1)
+      
+         ! compute
+         grid__get_fine_offset_cf(:,:)=grid_get_fine_offset( &
+         &                                         dd_lon0(:,:), dd_lat0(:,:),&
+         &                                         id_imin0, id_jmin0, &
+         &                                         id_imax0, id_jmax0, &
+         &                                         dl_lon1(:,:), dl_lat1(:,:),&
+         &                                         id_rho(:) )
+         
+         DEALLOCATE(dl_lon1, dl_lat1)
+      ENDIF
+
+      ! clean 
+      CALL mpp_clean(tl_coord1)
+      DEALLOCATE(il_rho)
+
+   END FUNCTION grid__get_fine_offset_cf
+   !-------------------------------------------------------------------
+   !> @brief This function get offset between fine grid and coarse grid.
+   !
+   !> @details
+   !> optionally, you could specify on which Arakawa grid point you want to
+   !> work (default 'T')
+   !> offset value could be 0,1,..,rho-1
+   !
+   !> @author J.Paul
+   !> - September, 2014- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] td_coord0 coarse grid coordinate 
+   !> @param[in] id_imin0  coarse grid lower left corner i-indice of fine grid domain
+   !> @param[in] id_jmin0  coarse grid lower left corner j-indice of fine grid domain
+   !> @param[in] id_imax0  coarse grid upper right corner i-indice of fine grid domain
+   !> @param[in] id_jmax0  coarse grid upper right corner j-indice of fine grid domain
+   !> @param[in] dd_lon1   fine   grid longitude array 
+   !> @param[in] dd_lat1   fine   grid latitude  array
+   !> @param[in] id_rho    array of refinement factor
+   !> @param[in] cd_point  Arakawa grid point
+   !> @return offset array (/ (/i_offset_left,i_offset_right/),(/j_offset_lower,j_offset_upper/) /)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_fine_offset_fc( td_coord0, &
+   &                                  id_imin0, id_jmin0, id_imax0, id_jmax0, &
+   &                                  dd_lon1, dd_lat1, &
+   &                                  id_rho, cd_point )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP)                      , INTENT(IN) :: td_coord0
+      REAL(dp)        , DIMENSION(:,:), INTENT(IN) :: dd_lon1
+      REAL(dp)        , DIMENSION(:,:), INTENT(IN) :: dd_lat1
+
+      INTEGER(i4)                     , INTENT(IN) :: id_imin0
+      INTEGER(i4)                     , INTENT(IN) :: id_jmin0
+      INTEGER(i4)                     , INTENT(IN) :: id_imax0
+      INTEGER(i4)                     , INTENT(IN) :: id_jmax0
+
+      INTEGER(i4)     , DIMENSION(:)  , INTENT(IN), OPTIONAL :: id_rho
+      CHARACTER(LEN=*)                , INTENT(IN), OPTIONAL :: cd_point
+
+      ! function
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_fine_offset_fc
+
+      ! local variable
+      INTEGER(i4) :: il_imin0
+      INTEGER(i4) :: il_jmin0
+      INTEGER(i4) :: il_imax0
+      INTEGER(i4) :: il_jmax0
+      
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
+      
+      INTEGER(i4), DIMENSION(2,2)         :: il_xghost0
+
+      CHARACTER(LEN= 1) :: cl_point
+      CHARACTER(LEN=lc) :: cl_name
+
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon0
+      REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lat0
+
+      TYPE(TVAR) :: tl_lon0
+      TYPE(TVAR) :: tl_lat0
+
+      TYPE(TMPP) :: tl_coord0
+      ! loop indices
+      !----------------------------------------------------------------
+      ! init
+      grid__get_fine_offset_fc(:,:)=-1
+
+      ALLOCATE(il_rho(ip_maxdim))
+      il_rho(:)=1
+      IF( PRESENT(id_rho) ) il_rho(:)=id_rho(:)
+
+      cl_point='T'
+      IF( PRESENT(cd_point) ) cl_point=TRIM(fct_upper(cd_point))
+
+      ! copy structure
+      tl_coord0=mpp_copy(td_coord0)
+
+      IF( .NOT. ASSOCIATED(tl_coord0%t_proc) )THEN
+         CALL logger_error("GRID GET FINE OFFSET: decompsition of mpp "//&
+         &  "file "//TRIM(tl_coord0%c_name)//" not defined." )
+      ELSE      
+         !1- Coarse grid
+         ! get ghost cell factor on coarse grid
+         il_xghost0(:,:)=grid_get_ghost( tl_coord0 )
+
+         ! open mpp files
+         CALL iom_mpp_open(tl_coord0)
+
+         ! read coarse longitue and latitude
+         WRITE(cl_name,*) 'longitude_'//TRIM(cl_point)
+         tl_lon0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         WRITE(cl_name,*) 'latitude_'//TRIM(cl_point)
+         tl_lat0=iom_mpp_read_var(tl_coord0, TRIM(cl_name))
+         
+         ! close mpp files
+         CALL iom_mpp_close(tl_coord0)
+
+         CALL grid_del_ghost(tl_lon0, il_xghost0(:,:))
+         CALL grid_del_ghost(tl_lat0, il_xghost0(:,:))
+
+         ALLOCATE(dl_lon0(tl_lon0%t_dim(jp_I)%i_len, &
+         &                tl_lon0%t_dim(jp_J)%i_len ))
+
+         dl_lon0(:,:)=tl_lon0%d_value(:,:,1,1)
+
+         ALLOCATE(dl_lat0(tl_lat0%t_dim(jp_I)%i_len, &
+         &                tl_lat0%t_dim(jp_J)%i_len ))
+
+         dl_lat0(:,:)=tl_lat0%d_value(:,:,1,1)
+
+         ! clean
+         CALL var_clean(tl_lon0)
+         CALL var_clean(tl_lat0)
+
+         ! adjust coarse grid indices
+         il_imin0=id_imin0-il_xghost0(jp_I,1)
+         il_imax0=id_imax0-il_xghost0(jp_I,1)
+
+         il_jmin0=id_jmin0-il_xghost0(jp_J,1)
+         il_jmax0=id_jmax0-il_xghost0(jp_J,1)
+
+      
+         !3- compute
+         grid__get_fine_offset_fc(:,:)=grid_get_fine_offset(&
+         &                                         dl_lon0(:,:), dl_lat0(:,:),&
+         &                                         il_imin0, il_jmin0, &
+         &                                         il_imax0, il_jmax0, &
+         &                                         dd_lon1(:,:), dd_lat1(:,:),&
+         &                                         id_rho(:) )
+         
+         DEALLOCATE(dl_lon0, dl_lat0)
+      ENDIF
+
+      ! clean
+      CALL mpp_clean(tl_coord0)
+      DEALLOCATE(il_rho)
+
+   END FUNCTION grid__get_fine_offset_fc
+   !-------------------------------------------------------------------
+   !> @brief This function get offset between fine grid and coarse grid.
    !
    !> @details
@@ -1543,22 +3585,21 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_lon0 : coarse grid longitude table 
-   !> @param[in] dd_lat0 : coarse grid latitude  table
-   !> @param[in] dd_lon1 : fine   grid longitude table 
-   !> @param[in] dd_lat1 : fine   grid latitude  table
-   !> @param[in] id_imin0 : coarse grid lower left corner i-indice of fine grid domain
-   !> @param[in] id_jmin0 : coarse grid lower left corner j-indice of fine grid domain
-   !> @param[in] id_imax0 : coarse grid upper right corner i-indice of fine grid domain
-   !> @param[in] id_jmax0 : coarse grid upper right corner j-indice of fine grid domain
-   !> @param[in] id_rhoi : i-direction refinement factor
-   !> @param[in] id_rhoj : j-direction refinement factor
-   !> @return offset table (/ (/i_offset_left,i_offset_right!/),(/j_offset_lower,j_offset_upper/) /)
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid_get_fine_offset( dd_lon0, dd_lat0, &
-   &                              id_imin0, id_jmin0, id_imax0, id_jmax0, &
-   &                              dd_lon1, dd_lat1, id_rho )
+   !> - November, 2013 - Initial Version
+   !> @date September, 2014 - rename from grid_get_fine_offset
+   !
+   !> @param[in] dd_lon0   coarse grid longitude array 
+   !> @param[in] dd_lat0   coarse grid latitude  array
+   !> @param[in] id_imin0  coarse grid lower left corner i-indice of fine grid domain
+   !> @param[in] id_jmin0  coarse grid lower left corner j-indice of fine grid domain
+   !> @param[in] id_imax0  coarse grid upper right corner i-indice of fine grid domain
+   !> @param[in] id_jmax0  coarse grid upper right corner j-indice of fine grid domain
+   !> @param[in] dd_lon1   fine   grid longitude array 
+   !> @param[in] dd_lat1   fine   grid latitude  array
+   !> @param[in] id_rho    array of refinement factor
+   !> @return offset array (/ (/i_offset_left,i_offset_right/),(/j_offset_lower,j_offset_upper/) /)
+   !-------------------------------------------------------------------
+   FUNCTION grid__get_fine_offset_cc( dd_lon0, dd_lat0, &
+   &                                  id_imin0, id_jmin0, id_imax0, id_jmax0, &
+   &                                  dd_lon1, dd_lat1, id_rho )
       IMPLICIT NONE
       ! Argument
@@ -1576,5 +3617,5 @@
 
       ! function
-      INTEGER(i4), DIMENSION(2,2) :: grid_get_fine_offset
+      INTEGER(i4), DIMENSION(2,2) :: grid__get_fine_offset_cc
 
       ! local variable
@@ -1584,7 +3625,4 @@
       REAL(dp)   , DIMENSION(:,:), ALLOCATABLE :: dl_lon1
       
-      REAL(dp) :: dl_dlon
-      REAL(dp) :: dl_dlat
-
       ! loop indices
       INTEGER(i4) :: ji
@@ -1616,62 +3654,70 @@
       WHERE( dd_lon1(:,:) < 0 ) dl_lon1(:,:)=dd_lon1(:,:)+360.         
 
-      grid_get_fine_offset(:,:)=-1
-
-      ! look for i-direction left offset 
-      IF( dl_lon1(1,1) < dl_lon0(id_imin0+1,id_jmin0) )THEN
-         DO ji=1,id_rho(jp_I)+2
-            dl_dlon=ABS(dl_lon1(ji+1,1)-dl_lon1(ji,1))*1.e-3
-            IF( dl_lon1(ji,1) > dl_lon0(id_imin0+1,id_jmin0) + dl_dlon )THEN
-               grid_get_fine_offset(1,1)=(id_rho(jp_I)+1)-ji+MOD(id_rho(jp_I),2)
-               EXIT
-            ENDIF
-         ENDDO
+      ! init
+      grid__get_fine_offset_cc(:,:)=-1
+
+      IF( il_shape1(1) > 1 )THEN
+
+         ! look for i-direction left offset 
+         IF( dl_lon1(1,1) < dl_lon0(id_imin0+1,id_jmin0) )THEN
+            DO ji=1,id_rho(jp_I)+2
+               IF( dl_lon1(ji,1) > dl_lon0(id_imin0+1,id_jmin0) - dp_delta )THEN
+                  grid__get_fine_offset_cc(1,1)=(id_rho(jp_I)+1)-ji
+                  EXIT
+               ENDIF
+            ENDDO
+         ELSE
+            CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
+            &                 " not match fine grid lower left corner.")
+         ENDIF
+
+         ! look for i-direction right offset
+         IF( dl_lon1(il_shape1(1),1) > dl_lon0(id_imax0-1,id_jmin0) )THEN
+            DO ji=1,id_rho(jp_I)+2
+               ii=il_shape1(1)-ji+1
+               IF( dl_lon1(ii,1) < dl_lon0(id_imax0-1,id_jmin0) + dp_delta )THEN
+                  grid__get_fine_offset_cc(1,2)=(id_rho(jp_I)+1)-ji
+                  EXIT
+               ENDIF
+            ENDDO
+         ELSE
+            CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
+            &                 " not match fine grid lower right corner.")
+         ENDIF
+
       ELSE
-         CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
-         &                 " not match fine grid lower left corner.")
-      ENDIF
-
-      ! look for i-direction right offset
-      IF( dl_lon1(il_shape1(1),1) > dl_lon0(id_imax0-1,id_jmin0) )THEN
-         DO ji=1,id_rho(jp_I)+2
-            ii=il_shape1(1)-ji+1
-            dl_dlon=ABS(dl_lon1(ii,1)-dl_lon1(ii-1,1))*1.e-3
-            IF( dl_lon1(ii,1) < dl_lon0(id_imax0-1,id_jmin0) - dl_dlon )THEN
-               grid_get_fine_offset(1,2)=(id_rho(jp_I)+1)-ji+MOD(id_rho(jp_I),2)
-               EXIT
-            ENDIF
-         ENDDO
+         grid__get_fine_offset_cc(1,:)=((id_rho(jp_I)-1)/2)
+      ENDIF
+
+      IF( il_shape1(2) > 1 )THEN
+
+         ! look for j-direction lower offset 
+         IF( dd_lat1(1,1) < dd_lat0(id_imin0,id_jmin0+1) )THEN
+            DO jj=1,id_rho(jp_J)+2
+               IF( dd_lat1(1,jj) > dd_lat0(id_imin0,id_jmin0+1) - dp_delta )THEN
+                  grid__get_fine_offset_cc(2,1)=(id_rho(jp_J)+1)-jj
+                  EXIT
+               ENDIF
+            ENDDO
+         ELSE
+            CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
+            &                 " not match fine grid upper left corner.")
+         ENDIF
+
+         ! look for j-direction upper offset 
+         IF( dd_lat1(1,il_shape1(2)) > dd_lat0(id_imin0,id_jmax0-1) )THEN
+            DO jj=1,id_rho(jp_J)+2
+               ij=il_shape1(2)-jj+1
+               IF( dd_lat1(1,ij) < dd_lat0(id_imin0,id_jmax0-1) + dp_delta )THEN
+                  grid__get_fine_offset_cc(2,2)=(id_rho(jp_J)+1)-jj
+                  EXIT
+               ENDIF
+            ENDDO
+         ELSE
+            CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
+            &                 " not match fine grid upper right corner.")
+         ENDIF
       ELSE
-         CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
-         &                 " not match fine grid lower right corner.")
-      ENDIF
-
-      ! look for j-direction lower offset 
-      IF( dd_lat1(1,1) < dd_lat0(id_imin0,id_jmin0+1) )THEN
-         DO jj=1,id_rho(jp_J)+2
-            dl_dlat=ABS(dd_lat1(1,jj+1)-dd_lat1(1,jj))*1.e-3
-            IF( dd_lat1(1,jj) > dd_lat0(id_imin0,id_jmin0+1) + dl_dlat )THEN
-               grid_get_fine_offset(2,1)=(id_rho(jp_J)+1)-jj+MOD(id_rho(jp_J),2)
-               EXIT
-            ENDIF
-         ENDDO
-      ELSE
-         CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
-         &                 " not match fine grid upper left corner.")
-      ENDIF
-
-      ! look for j-direction upper offset 
-      IF( dd_lat1(1,il_shape1(2)) > dd_lat0(id_imin0,id_jmax0-1) )THEN
-         DO jj=1,id_rho(jp_J)+2
-            ij=il_shape1(2)-jj+1
-            dl_dlat=ABS(dd_lat1(1,ij)-dd_lat1(1,ij-1))*1.e-3
-            IF( dd_lat1(1,ij) < dd_lat0(id_imin0,id_jmax0-1) - dl_dlat )THEN
-               grid_get_fine_offset(2,2)=(id_rho(jp_J)+1)-jj+MOD(id_rho(jp_J),2)
-               EXIT
-            ENDIF
-         ENDDO
-      ELSE
-         CALL logger_error("GRID GET FINE OFFSET: coarse grid indices do "//&
-         &                 " not match fine grid upper right corner.")
+         grid__get_fine_offset_cc(2,:)=((id_rho(jp_J)-1)/2)
       ENDIF
 
@@ -1679,137 +3725,23 @@
       DEALLOCATE( dl_lon1 )
 
-   END FUNCTION grid_get_fine_offset
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function check if ghost cell are used or not, and return ghost
-   !> cell factor (0,1) in i- and j-direction.
+   END FUNCTION grid__get_fine_offset_cc
+   !-------------------------------------------------------------------
+   !> @brief This subroutine check fine and coarse grid coincidence.
    !
    !> @details
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_lon  : grid longitude sturcture 
-   !> @param[in] td_lat  : grid latitude  structure
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid__get_ghost_ll( td_lon, td_lat )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TVAR), INTENT(IN) :: td_lon
-      TYPE(TVAR), INTENT(IN) :: td_lat
-
-      ! function
-      INTEGER(i4), DIMENSION(2) :: grid__get_ghost_ll
-
-      ! local variable
-      INTEGER(i4) :: il_ew
-      ! loop indices
-      !----------------------------------------------------------------
-      ! init
-      grid__get_ghost_ll(:)=0
-
-      IF( grid_is_global(td_lon, td_lat) )THEN
-         grid__get_ghost_ll(:)=0
-      ELSE
-         grid__get_ghost_ll(2)=1
-
-         il_ew=td_lon%i_ew
-         IF( il_ew < 0 )THEN
-            grid__get_ghost_ll(1)=1
-         ELSE
-            grid__get_ghost_ll(1)=0
-         ENDIF
-      ENDIF
-
-   END FUNCTION grid__get_ghost_ll
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function check if ghost cell are used or not, and return ghost
-   !> cell factor (0,1) in i- and j-direction.
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file sturcture 
-   !-------------------------------------------------------------------
-   !> @code
-   FUNCTION grid__get_ghost_f( td_file )
-      IMPLICIT NONE
-      ! Argument
-      TYPE(TFILE), INTENT(IN) :: td_file
-
-      ! function
-      INTEGER(i4), DIMENSION(2) :: grid__get_ghost_f
-
-      ! local variable
-      TYPE(TVAR)  :: tl_lon
-      TYPE(TVAR)  :: tl_lat
-
-      INTEGER(i4) :: il_lonid
-      INTEGER(i4) :: il_latid
-      ! loop indices
-      INTEGER(i4)  :: ji
-      !----------------------------------------------------------------
-      ! init
-      grid__get_ghost_f(:)=0
-
-      IF( td_file%i_id == 0 )THEN
-         CALL logger_error("GRID GET GHOST: file "//&
-         &                 TRIM(td_file%c_name)//" not opened." )
-
-      ELSE
-
-         IF( ASSOCIATED(td_file%t_var) )THEN
-            ! read coarse longitue and latitude
-            il_lonid=var_get_id(td_file%t_var(:),'longitude')
-            il_latid=var_get_id(td_file%t_var(:),'latitude')
-
-            print *,'file ',trim(td_file%c_name),td_file%i_ew
-            DO ji=1,td_file%i_nvar
-               print *,ji,trim(td_file%t_var(ji)%c_name),': ',td_file%t_var(ji)%i_ew
-            ENDDO
-            print *,'lonid ',il_lonid
-            print *,'latid ',il_latid
-            IF( il_lonid /=0 .AND. il_latid /= 0 )THEN
-               tl_lon=iom_read_var(td_file,il_lonid)
-               print *,'lon ',tl_lon%i_ew
-               tl_lat=iom_read_var(td_file,il_latid)
-               print *,'lat ',tl_lat%i_ew
-               ! get ghost cell factor on coarse grid
-               grid__get_ghost_f(:)=grid_get_ghost( tl_lon, tl_lat )
-            ELSE
-               CALL logger_error("GRID GET GHOST: can not find "//&
-               &           "longitude or latitude "//&
-               &           "in file "//TRIM(td_file%c_name))
-            ENDIF
-         ELSE
-           CALL logger_error("GRID GET GHOST: no variable "//&
-           &           "associated to file "//TRIM(td_file%c_name))
-         ENDIF
-
-      ENDIF
-
-   END FUNCTION grid__get_ghost_f
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine check fine and coarse grid coincidence
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_coord0 : coarse grid coordinate file structure 
-   !> @param[in] td_coord1 : fine   grid coordinate file structure 
-   !> @param[in] id_imin0 : coarse grid lower left  corner i-indice of fine grid domain 
-   !> @param[in] id_imax0 : coarse grid upper right corner i-indice of fine grid domain
-   !> @param[in] id_jmin0 : coarse grid lower left  corner j-indice of fine grid domain 
-   !> @param[in] id_jmax0 : coarse grid upper right corner j-indice of fine grid domain  
-   !> @param[in] id_rho   : table of refinement factor 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - work on mpp file structure instead of file structure
+   !
+   !> @param[in] td_coord0 coarse grid coordinate file structure 
+   !> @param[in] td_coord1 fine   grid coordinate file structure 
+   !> @param[in] id_imin0  coarse grid lower left  corner i-indice of fine grid domain 
+   !> @param[in] id_imax0  coarse grid upper right corner i-indice of fine grid domain
+   !> @param[in] id_jmin0  coarse grid lower left  corner j-indice of fine grid domain 
+   !> @param[in] id_jmax0  coarse grid upper right corner j-indice of fine grid domain  
+   !> @param[in] id_rho    array of refinement factor (default 1) 
+   !-------------------------------------------------------------------
    SUBROUTINE grid_check_coincidence( td_coord0, td_coord1, &
    &                                  id_imin0, id_imax0, &
